void gibbs2_parameter(DATA, BACK, STAT, AUXB, AUX, line)
int **DATA, **BACK, *AUXB, *AUX, line; 
double *STAT;
{
	int i, j, k, xline;
	int **M1DATA, **M2DATA, **M3DATA;
	double num1, num2, denom, ratio1, ratio2, ratio3, u;
	double *M1STAT, *M2STAT, *M3STAT;
	
	M1STAT = dvector(1, nPARA2 + nCOEF2 + 1);
	M2STAT = dvector(1, nPARA2 + nCOEF2 + 1);
	M3STAT = dvector(1, nPARA2 + nCOEF2 + 1);
	
	M1DATA = imatrix(1, nSPAT, 1, TOOTH + 1);
	M2DATA = imatrix(1, nSPAT, 1, TOOTH + 1);
	M3DATA = imatrix(1, nSPAT, 1, TOOTH + 1);

	for(i = 1; i <= nSPAT; i++){
		for(j = 1; j <= TOOTH; j++) M1DATA[i][j] = M2DATA[i][j] = M3DATA[i][j] = DATA[i][j];
		M1DATA[i][(TOOTH+1)] = M2DATA[i][(TOOTH+1)] = M3DATA[i][(TOOTH+1)] = 0;
	}
	if(line % 2 == 0) xline = line / 2;
	else xline = (line + 1) / 2;
	
	for(i = 1; i <= nSPAT; i++)
		for(j = 1; j <= TOOTH; j++)
			if(BACK[i][j] == 1 && DATA[i][j] != 0){
				M1DATA[i][j] = 1; M2DATA[i][j] = 2; M3DATA[i][j] = 3;
				for(k = 1; k <= nPARA2 + nCOEF2; k++) M1STAT[k] = M2STAT[k] = M3STAT[k] = 0.0;
				
				num1 = num2 = 0.0;
				if(DATA[i][j] == 1){
					cost2(M1DATA, BACK, M1STAT, AUXB, AUX, line);
					for(k = 1; k <= nPARA2 + nCOEF2 + 1; k++) M2STAT[k] = M3STAT[k] = M1STAT[k];
					update_cost2(M2DATA, M1DATA, BACK, M2STAT, AUXB, AUX, line, j, i);
					update_cost2(M3DATA, M1DATA, BACK, M3STAT, AUXB, AUX, line, j, i);

					for(k = 1; k <= nPARA2 + nCOEF2; k++){
						num1 += newtheta_P[k] * (M2STAT[k] - M1STAT[k]);
						num2 += newtheta_P[k] * (M3STAT[k] - M1STAT[k]);
					}
					num1 += oldeffect_P[xline] * (M2STAT[(nPARA2+nCOEF2+1)] - M1STAT[(nPARA2+nCOEF2+1)]);
					num2 += oldeffect_P[xline] * (M3STAT[(nPARA2+nCOEF2+1)] - M1STAT[(nPARA2+nCOEF2+1)]);
					
					denom = 1.0 + exp(num1) + exp(num2);
					ratio1 = 1.0 / denom;
					ratio2 = exp(num1) / denom;
					ratio3 = exp(num2) / denom;
				}
				else if(DATA[i][j] == 2){
					cost2(M2DATA, BACK, M2STAT, AUXB, AUX, line);
					for(k = 1; k <= nPARA2 + nCOEF2 + 1; k++) M1STAT[k] = M3STAT[k] = M2STAT[k];
					update_cost2(M1DATA, M2DATA, BACK, M1STAT, AUXB, AUX, line, j, i);
					update_cost2(M3DATA, M2DATA, BACK, M3STAT, AUXB, AUX, line, j, i);

					for(k = 1; k <= nPARA2 + nCOEF2; k++){
						num1 += newtheta_P[k] * (M1STAT[k] - M2STAT[k]);
						num2 += newtheta_P[k] * (M3STAT[k] - M2STAT[k]);
					}
					num1 += oldeffect_P[xline] * (M1STAT[(nPARA2+nCOEF2+1)] - M2STAT[(nPARA2+nCOEF2+1)]);
					num2 += oldeffect_P[xline] * (M3STAT[(nPARA2+nCOEF2+1)] - M2STAT[(nPARA2+nCOEF2+1)]);
					denom = 1.0 + exp(num1) + exp(num2);
					ratio1 = exp(num1) / denom;
					ratio2 = 1.0 / denom;
					ratio3 = exp(num2) / denom;
				}
				else {
					cost2(M3DATA, BACK, M3STAT, AUXB, AUX, line);
					for(k = 1; k <= nPARA2 + nCOEF2 + 1; k++) M1STAT[k] = M2STAT[k] = M3STAT[k];
					update_cost2(M1DATA, M3DATA, BACK, M1STAT, AUXB, AUX, line, j, i);
					update_cost2(M2DATA, M3DATA, BACK, M2STAT, AUXB, AUX, line, j, i);

					for(k = 1; k <= nPARA2 + nCOEF2; k++){
						num1 += newtheta_P[k] * (M1STAT[k] - M3STAT[k]);
						num2 += newtheta_P[k] * (M2STAT[k] - M3STAT[k]);
					}
					num1 += oldeffect_P[xline] * (M1STAT[(nPARA2+nCOEF2+1)] - M3STAT[(nPARA2+nCOEF2+1)]);
					num2 += oldeffect_P[xline] * (M2STAT[(nPARA2+nCOEF2+1)] - M3STAT[(nPARA2+nCOEF2+1)]);
					denom = 1.0 + exp(num1) + exp(num2);
					ratio1 = exp(num1) / denom;
					ratio2 = exp(num2) / denom;
					ratio3 = 1.0 / denom;
				}

				u = 0.0; while(u <= 0.0 || u >= 1.0) u = rand() * 1.0 / RAND_MAX;
				if(u < ratio1) M1DATA[i][j] = M2DATA[i][j] = M3DATA[i][j] = DATA[i][j] = 1;
				else if(u < ratio1 + ratio2) M1DATA[i][j] = M2DATA[i][j] = M3DATA[i][j] = DATA[i][j] = 2;
				else M1DATA[i][j] = M2DATA[i][j] = M3DATA[i][j] = DATA[i][j] = 3;
			}
	
	for(k = 1; k <= nPARA2 + nCOEF2 + 1; k++) STAT[k] = 0.0;
	cost2(DATA, BACK, STAT, AUXB, AUX, line);
	Yeffstat_P[line] = STAT[(nPARA2 + nCOEF2 + 1)];
					   
	free_dvector(M1STAT, 1, nPARA2 + nCOEF2 + 1);
	free_dvector(M2STAT, 1, nPARA2 + nCOEF2 + 1);
	free_dvector(M3STAT, 1, nPARA2 + nCOEF2 + 1);

	free_imatrix(M1DATA, 1, nSPAT, 1, TOOTH + 1);
	free_imatrix(M2DATA, 1, nSPAT, 1, TOOTH + 1);
	free_imatrix(M3DATA ,1, nSPAT, 1, TOOTH + 1);
	return;
}
